diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/text_doc.cpp lmi-editor/text_doc.cpp
--- cvs/text_doc.cpp	2008-01-10 18:31:47.000000000 +0100
+++ lmi-editor/text_doc.cpp	2008-01-30 21:04:28.000000000 +0100
@@ -89,26 +89,13 @@
         }
 }
 
-bool TextEditDocument::OnOpenDocument(wxString const& filename)
+bool TextEditDocument::DoOpenDocument(wxString const& filename)
 {
-    if(!PredominantViewWindow().LoadFile(filename))
-        {
-        return false;
-        }
-
-    SetFilename(filename, true);
-    Modify(false);
-    UpdateAllViews();
-    return true;
+    return PredominantViewWindow().LoadFile(filename);
 }
 
-bool TextEditDocument::OnSaveDocument(wxString const& filename)
+bool TextEditDocument::DoSaveDocument(wxString const& filename)
 {
-    if(!PredominantViewWindow().SaveFile(filename))
-        {
-        return false;
-        }
-    Modify(false);
-    return true;
+    return PredominantViewWindow().SaveFile(filename);
 }
 
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/text_doc.hpp lmi-editor/text_doc.hpp
--- cvs/text_doc.hpp	2008-01-10 18:31:47.000000000 +0100
+++ lmi-editor/text_doc.hpp	2008-01-30 21:04:28.000000000 +0100
@@ -30,7 +30,7 @@
 // copyright notice above.
 
 // Because text windows have their own functions for loading and saving
-// files, override OnOpenDocument() and OnSaveDocument() instead of
+// files, override DoOpenDocument() and DoSaveDocument() instead of
 // LoadObject and SaveObject.
 
 #ifndef text_doc_hpp
@@ -53,8 +53,8 @@
     // wxDocument overrides.
     virtual bool IsModified() const;
     virtual void Modify(bool);
-    virtual bool OnOpenDocument(wxString const& filename);
-    virtual bool OnSaveDocument(wxString const& filename);
+    virtual bool DoOpenDocument(wxString const& filename);
+    virtual bool DoSaveDocument(wxString const& filename);
 
     wxTextCtrl& PredominantViewWindow() const;
 
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/tier_document.cpp lmi-editor/tier_document.cpp
--- cvs/tier_document.cpp	2008-01-10 18:31:47.000000000 +0100
+++ lmi-editor/tier_document.cpp	2008-02-08 14:57:58.000000000 +0100
@@ -35,17 +35,45 @@
 
 #include <wx/defs.h>
 
+#include <cfloat> // DBL_MAX
+#include <vector>
+
 IMPLEMENT_DYNAMIC_CLASS(TierDocument, ProductEditorDocument)
 
 TierDocument::TierDocument()
     :ProductEditorDocument()
     ,charges_()
-{}
+{
+    initialize_charges();
+}
 
 TierDocument::~TierDocument()
 {
 }
 
+void TierDocument::initialize_charges()
+{
+    typedef std::map<e_stratified, stratified_entity> dictionary_t;
+
+    charges_.initialize_dictionary();
+
+    stratified_entity dummy_entity
+        (std::vector<double>(1, DBL_MAX) // limits
+        ,std::vector<double>(1, 0)       // values
+        );
+
+    for
+        (dictionary_t::iterator it = charges_.dictionary.begin()
+        ,                       end = charges_.dictionary.end()
+        ;it != end
+        ;++it
+        )
+        {
+        it->second = dummy_entity;
+        }
+}
+
+
 void TierDocument::ReadDocument(std::string const& filename)
 {
     charges_.read(filename);
@@ -56,8 +84,8 @@
     charges_.write(filename);
 }
 
-stratified_entity* TierDocument::get_stratified_entity(e_stratified index)
+stratified_entity& TierDocument::get_stratified_entity(e_stratified index)
 {
-    return &charges_.raw_entity(index);
+    return charges_.raw_entity(index);
 }
 
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/tier_document.hpp lmi-editor/tier_document.hpp
--- cvs/tier_document.hpp	2008-01-10 18:31:47.000000000 +0100
+++ lmi-editor/tier_document.hpp	2008-01-30 21:04:28.000000000 +0100
@@ -27,7 +27,6 @@
 #include "config.hpp"
 
 #include "product_editor.hpp"
-
 #include "stratified_charges.hpp"
 
 class TierDocument
@@ -37,13 +36,15 @@
     TierDocument();
     virtual ~TierDocument();
 
-    stratified_entity* get_stratified_entity(e_stratified index);
+    stratified_entity& get_stratified_entity(e_stratified index);
 
   private:
     // wxDocument overrides.
     virtual void ReadDocument (std::string const& filename);
     virtual void WriteDocument(std::string const& filename);
 
+    void initialize_charges();
+
     stratified_charges charges_;
 
     DECLARE_DYNAMIC_CLASS(TierDocument)
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/tier_view.cpp lmi-editor/tier_view.cpp
--- cvs/tier_view.cpp	2008-01-10 18:31:47.000000000 +0100
+++ lmi-editor/tier_view.cpp	2008-01-30 21:04:28.000000000 +0100
@@ -28,9 +28,7 @@
 
 #include "tier_view.hpp"
 
-// EVGENIY !! Are all three 'multidimgrid*' headers required here?
 #include "multidimgrid_any.hpp"
-#include "multidimgrid_safe.tpp"
 #include "multidimgrid_tools.hpp"
 #include "safely_dereference_as.hpp"
 #include "stratified_charges.hpp"
@@ -40,6 +38,7 @@
 #include "wx_new.hpp"
 
 #include <wx/icon.h>
+#include <wx/sizer.h>
 #include <wx/treectrl.h>
 #include <wx/window.h>
 
@@ -69,6 +68,32 @@
     return static_tier_entity_infos;
 }
 
+/// Stores additional information in a wxTree node
+
+class tier_tree_item_data
+  :public wxTreeItemData
+{
+  public:
+    tier_tree_item_data(tier_entity_info const&);
+    virtual ~tier_tree_item_data() {}
+
+    tier_entity_info const& entity_info() const;
+
+  private:
+    tier_entity_info const& entity_info_;
+};
+
+tier_tree_item_data::tier_tree_item_data(tier_entity_info const& entity_info)
+    :wxTreeItemData()
+    ,entity_info_(entity_info)
+{
+}
+
+tier_entity_info const& tier_tree_item_data::entity_info() const
+{
+    return entity_info_;
+}
+
 } // unnamed namespace
 
 IMPLEMENT_DYNAMIC_CLASS(TierView, TreeGridViewBase)
@@ -87,10 +112,10 @@
 {
 }
 
-wxTreeCtrl* TierView::CreateTreeCtrl(wxWindow* panel)
+wxTreeCtrl* TierView::CreateTreeCtrl(wxWindow* parent)
 {
     return new(wx) AutoResizingTreeCtrl
-        (panel
+        (parent
         ,wxID_ANY
         ,wxDefaultPosition
         ,wxDefaultSize
@@ -98,9 +123,9 @@
         );
 }
 
-MultiDimGrid* TierView::CreateGridCtrl(wxWindow* panel)
+MultiDimGrid* TierView::CreateGridCtrl(wxWindow* parent)
 {
-    return new(wx) TierEditorGrid(panel, table_adapter_);
+    return new(wx) TierEditorGrid(parent, table_adapter_);
 }
 
 void TierView::SetupControls()
@@ -108,31 +133,31 @@
     std::vector<tier_entity_info> const& entities = get_tier_entity_infos();
     std::map<e_stratified, wxTreeItemId> index_to_id;
 
-    wxTreeCtrl& tree = GetTreeCtrl();
+    wxTreeCtrl& tree_ctrl = tree();
 
     for(std::size_t i = 0; i < entities.size(); ++i)
         {
         tier_entity_info const& entity = entities[i];
         if(entity.index == entity.parent_index)
             {
-            wxTreeItemId id = tree.AddRoot("");
+            wxTreeItemId id = tree_ctrl.AddRoot("");
             index_to_id[entity.index] = id;
             }
         else
             {
-            wxTreeItemId id = tree.AppendItem
+            wxTreeItemId id = tree_ctrl.AppendItem
                 (index_to_id[entity.parent_index]
                 ,entity.short_name
                 ,-1
                 ,-1
-                ,new(wx) TierTreeItemData(i, entity.long_name)
+                ,new(wx) tier_tree_item_data(entity)
                 );
             index_to_id[entity.index] = id;
             }
         }
 
     // Force BestSize to be recalculated, since we have added new items
-    GetTreeCtrl().InvalidateBestSize();
+    tree_ctrl.InvalidateBestSize();
 }
 
 wxIcon TierView::Icon() const
@@ -162,20 +187,16 @@
 
 void TierView::UponTreeSelectionChange(wxTreeEvent& event)
 {
-    wxTreeCtrl& tree = GetTreeCtrl();
-    TierTreeItemData* item_data = dynamic_cast<TierTreeItemData*>
-        (tree.GetItemData(event.GetItem())
+    wxTreeCtrl& tree_ctrl = tree();
+    tier_tree_item_data* item_data = dynamic_cast<tier_tree_item_data*>
+        (tree_ctrl.GetItemData(event.GetItem())
         );
 
     if(item_data)
         {
-        std::size_t index = item_data->get_id();
+        bool is_topic = tree_ctrl.GetChildrenCount(event.GetItem());
 
-        bool is_topic = tree.GetChildrenCount(event.GetItem());
-
-        SetLabel(item_data->get_description());
-
-        std::vector<tier_entity_info> const& entities = get_tier_entity_infos();
+        set_grid_label_text(item_data->entity_info().long_name);
 
         if(is_topic)
             {
@@ -183,17 +204,22 @@
             }
         else
             {
-            stratified_entity& entity =
-                *document().get_stratified_entity(entities[index].index);
+            stratified_entity& entity = document().get_stratified_entity
+                (item_data->entity_info().index
+                );
             table_adapter_->SetTierEntity
                 (tier_entity_adapter(entity.limits_, entity.values_)
                 );
             }
 
-        MultiDimGrid& grid = GetGridCtrl();
+        MultiDimGrid& grid_ctrl = grid();
+
+        wxSizer* sizer = grid_ctrl.GetContainingSizer();
+        LMI_ASSERT(sizer);
+        sizer->Show(&grid_ctrl, !is_topic);
+        sizer->Layout();
 
-        grid.Enable(!is_topic);
-        grid.RefreshTableFull();
+        grid_ctrl.RefreshTableFull();
         }
 }
 
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/tier_view_editor.cpp lmi-editor/tier_view_editor.cpp
--- cvs/tier_view_editor.cpp	2008-01-10 18:31:47.000000000 +0100
+++ lmi-editor/tier_view_editor.cpp	2008-01-30 21:04:28.000000000 +0100
@@ -25,8 +25,11 @@
 
 #include "assert_lmi.hpp"
 #include "multidimgrid_safe.tpp"
+#include "stratified_charges.hpp"
 #include "value_cast.hpp"
 
+#include <cfloat> // DBL_MAX
+
 void tier_entity_adapter::ensure_not_void() const
 {
     LMI_ASSERT(!is_void());
@@ -37,7 +40,8 @@
     LMI_ASSERT(band < limits().size());
 }
 
-double_pair tier_entity_adapter::get_value(unsigned int band) const
+tier_entity_adapter::double_pair
+tier_entity_adapter::get_value(unsigned int band) const
 {
     ensure_not_void();
     ensure_valid_band_number(band);
@@ -99,19 +103,22 @@
         }
 }
 
-double_pair TierTableAdapter::GetValue(unsigned int band) const
+TierTableAdapter::double_pair
+TierTableAdapter::DoGetValue(Coords const& coords) const
 {
     if(entity_.is_void())
         {return double_pair(0,0);}
 
+    unsigned int const band = UnwrapAny<unsigned int>(coords[0]);
     return entity_.get_value(band);
 }
 
-void TierTableAdapter::SetValue(unsigned int band, double_pair const& value)
+void TierTableAdapter::DoSetValue(Coords const& coords, double_pair const& value)
 {
     if(entity_.is_void())
         {return;}
 
+    unsigned int const band = UnwrapAny<unsigned int>(coords[0]);
     entity_.set_value(band, value);
     SetModified();
 }
@@ -165,19 +172,26 @@
     return updated;
 }
 
-MultiDimAxis<unsigned int>* TierTableAdapter::GetAxis0()
+MultiDimTableAny::AxesAny TierTableAdapter::DoGetAxesAny()
 {
-    return new TierBandAxis();
+    AxesAny axes(1);
+    axes[0] = AxisAnyPtr(new TierBandAxis());
+    return axes;
 }
 
 // ---------------------------
 // TierEditorGrid implementation
 // ---------------------------
-enum e_tier_grid_columns
-    {tgc_limit = 0
-    ,tgc_value
-    ,tgc_max
-    };
+
+std::string TierEditorGrid::highest_representable_label_("MAXIMUM");
+
+TierEditorGrid::TierEditorGrid()
+{
+}
+
+TierEditorGrid::~TierEditorGrid()
+{
+}
 
 TierEditorGrid::TierEditorGrid
     (wxWindow* parent
@@ -186,79 +200,73 @@
     ,wxPoint const& pos
     ,wxSize const& size
     )
-    :MultiDimGrid(parent, table, id, pos, size)
 {
+    // We use default MultiDimGrid constructor and Create() call here, because
+    // MultiDimGrid constructor/Create calls some of the methods TierEditorGrid
+    // overrides, so the object has to be fully constructed by the time
+    // MultiDimGrid::Create() is called.
+    Create(parent, table, id, pos, size);
 }
 
-TierEditorGrid::~TierEditorGrid()
+bool TierEditorGrid::Create
+    (wxWindow* parent
+    ,boost::shared_ptr<TierTableAdapter> const& table
+    ,wxWindowID id
+    ,wxPoint const& pos
+    ,wxSize const& size
+    )
 {
+    return MultiDimGrid::Create(parent, table, id, pos, size);
 }
 
-int TierEditorGrid::GetNumberRows()
+unsigned int TierEditorGrid::DoGetNumberRows() const
 {
-    return MultiDimGrid::GetNumberCols();
+    return MultiDimGrid::DoGetNumberCols();
 }
 
-int TierEditorGrid::GetNumberCols()
+unsigned int TierEditorGrid::DoGetNumberCols() const
 {
-    return tgc_max;
+    return e_column_max;
 }
 
-// EVGENIY !! Isn't the 'row' parameter unused? It appears that
-// this function checks only the 'col', not 'row'. Is there any
-// constraint on 'row' that should be enforced here? It looks like
-// this function is called as a precondition test for most member
-// functions, but not for GetDoublePairValue(), which takes only a
-// 'row' argument; but if we add a test for 'row' here, then that
-// function should probably call this one, too. Wouldn't it be
-// better to find some other way to write this, as suggested under
-// GetValue() below?
-
-void TierEditorGrid::CheckRowAndCol(int row, int col) const
+TierEditorGrid::enum_tier_grid_column TierEditorGrid::EnsureValidColumn
+    (int col
+    ) const
 {
-    if(col != tgc_limit && col != tgc_value)
+    if(col != e_column_limit && col != e_column_value)
         {
         fatal_error()
             << "Grid has only two columns: Limit and Value."
             << LMI_FLUSH
             ;
         }
+    return static_cast<enum_tier_grid_column>(col);
 }
 
-// EVGENIY !! Consider the conditional operator in this function.
-// Here's how I read it:
-//
-//   switch(col)
-//     case tgc_limit: /* use value.first  */ ; break;
-//     case tgc_value: /* use value.second */ ; break;
-//     case tgc_max:   /* assume that this is impossible */ goto tgc_value;
-//     default:        /* assume that this is impossible */ goto tgc_value;
-//
-// And there are other places where the code assumes that only the
-// first two enumerator values are possible. That's in effect
-// asserted by CheckRowAndCol(), but I didn't perceive that at first.
-// Is there a way to write this more clearly? Should a UDT be used
-// instead of int? Should the base class test these arguments against
-// the maximum? Do any other ideas occur to you?
-
-wxString TierEditorGrid::GetValue(int row, int col)
-{
-    CheckRowAndCol(row, col);
-    double_pair value = GetDoublePairValue(static_cast<unsigned int>(row));
-    return value_cast<std::string>(col == tgc_limit ? value.first : value.second);
-}
-
-void TierEditorGrid::SetValue(int row, int col, wxString const& str)
+std::string TierEditorGrid::DoGetValue
+    (unsigned int row
+    ,unsigned int col
+    ) const
+{
+    double_pair const value = GetDoublePairValue(row);
+    double const dbl_value =
+          EnsureValidColumn(col) == e_column_limit
+        ? value.first
+        : value.second
+        ;
+    return DoubleToString(dbl_value);
+}
+
+void TierEditorGrid::DoSetValue
+    (unsigned int row
+    ,unsigned int col
+    ,std::string const& text
+    )
 {
-    CheckRowAndCol(row, col);
     double_pair value = GetDoublePairValue(row);
 
-    double as_double;
-    if(!str.ToDouble(&as_double))
-        {
-        as_double = 0;
-        }
-    if(col == tgc_limit)
+    double const as_double = StringToDouble(text);
+    if(EnsureValidColumn(col) == e_column_limit)
         {
         value.first = as_double;
         }
@@ -267,30 +275,46 @@
         value.second = as_double;
         }
 
-    table_->SetAnyValue(axis_fixed_coords_, boost::any(value));
+    dynamic_cast<TierTableAdapter&>(table()).SetValue
+        (PrepareFixedCoords(0, row)
+        ,value);
 }
 
-wxString TierEditorGrid::GetRowLabelValue(int row)
+std::string TierEditorGrid::DoGetRowLabelValue(unsigned int row) const
 {
-    CheckRowAndCol(row, 1);
-    return MultiDimGrid::GetColLabelValue(row);
+    return MultiDimGrid::DoGetColLabelValue(row);
 }
 
-wxString TierEditorGrid::GetColLabelValue(int col)
+std::string TierEditorGrid::DoGetColLabelValue(unsigned int col) const
 {
-    CheckRowAndCol(1, col);
-    if(col == tgc_limit)
+    if(EnsureValidColumn(col) == e_column_limit)
         {return "Limit";}
     return "Value";
 }
 
-double_pair TierEditorGrid::GetDoublePairValue(int row)
+TierEditorGrid::double_pair
+TierEditorGrid::GetDoublePairValue(int band) const
 {
-    // hide first axis from the table
-    PrepareFixedCoords(0, row);
+    return dynamic_cast<TierTableAdapter const&>(table()).GetValue
+        (PrepareFixedCoords(0, band)
+        );
+}
 
-    boost::any value = table_->GetAnyValue(axis_fixed_coords_);
+std::string TierEditorGrid::DoubleToString(double value)
+{
+    if(stratified_entity::is_highest_representable(value))
+        {
+        return highest_representable_label_;
+        }
+    return value_cast<std::string>(value);
+}
 
-    return boost::any_cast<double_pair>(value);
+double TierEditorGrid::StringToDouble(std::string const& text)
+{
+    if(text == highest_representable_label_)
+        {
+        return DBL_MAX;
+        }
+    return value_cast<double>(text);
 }
 
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/tier_view_editor.hpp lmi-editor/tier_view_editor.hpp
--- cvs/tier_view_editor.hpp	2008-01-25 21:20:01.000000000 +0100
+++ lmi-editor/tier_view_editor.hpp	2008-01-30 21:04:28.000000000 +0100
@@ -34,54 +34,33 @@
 
 #include <boost/shared_ptr.hpp>
 
-#include <wx/treectrl.h>
-
 #include <string>
 #include <utility> // std::pair
 
-// EVGENIY !! Can we avoid writing typedefs at global scope, in order
-// to keep them out of the global namespace?
-typedef std::pair<double, double> double_pair;
-
-/// Stores additional information in a wxTree node
-
-class TierTreeItemData
-  :public wxTreeItemData
-{
-  public:
-    TierTreeItemData(std::size_t, std::string const&);
-
-    std::size_t get_id() const;
-    std::string const& get_description() const;
-
-  private:
-    std::size_t id_;
-    std::string description_;
-};
-
-inline TierTreeItemData::TierTreeItemData
-    (std::size_t id
-    ,std::string const& description
-    )
-    :wxTreeItemData()
-    ,id_(id)
-    ,description_(description)
-{
-}
-inline std::size_t TierTreeItemData::get_id() const
-{
-    return id_;
-}
-inline std::string const& TierTreeItemData::get_description() const
-{
-    return description_;
-}
+/// Notes on TierEditorGrid and TierTableAdapter.
+///
+/// The data being manipulated is a set of pairs of doubles. Because of that
+/// from the point of view of TierTableAdapter the problem is one dimensional.
+/// But from the user's point of view it is two dimensional problem with the
+/// second dimension being restrained to the set [0, 1] - first and second
+/// component of every pair of doubles.
+///
+/// That's why TierTableAdapter manipulates a one dimensional set of values
+/// while TierEditorGrid presents it to the user as a two dimensional set
+/// of doubles. For that to work TierEditorGrid overrides default MultiDimGrid
+/// behaviour and translates two dimensions into one dimension x [0,1].
+/// As a consequence the default implementation of
+/// TierEditorGrid::ValueToString and TierEditorGrid::String2Value
+/// forces us to define conversions between double_pair and std::string.
+/// See below.
 
 /// tier_entity_adapter
 
 class tier_entity_adapter
 {
   public:
+    typedef std::pair<double, double> double_pair;
+
     /// We can't store a pointer/reference to stratified_entity because
     /// stratified_entity has private interface for accessing
     /// its limits_ and values_ data members. Therefore we are storing
@@ -93,17 +72,15 @@
         ,std::vector<double>& values
         );
 
-    /// get data in pairs (corresponding to a band)
+    /// Access data in pairs (corresponding to a band).
     double_pair get_value(unsigned int band) const;
-    /// set data in a pair (corresponding to a band)
     void set_value(unsigned int band, double_pair const& value);
 
-    /// Change number of bands in the underlying stratified_entity object
-    void set_bands_count(unsigned int n);
-    /// Read the number of bands in the underlying stratified_entity object
+    /// Access the underlying stratified_entity object number of bands.
     unsigned int get_bands_count() const;
+    void set_bands_count(unsigned int n);
 
-    /// return true if we have no underlying object to manipulate
+    /// Return true if there is no underlying object to manipulate.
     bool is_void() const;
 
     std::vector<double>&       limits();
@@ -190,35 +167,29 @@
 {
 }
 
-/// Note.
-///
-/// MultiDimTable1<double_pair, unsigned int> requires a specification of
-/// MultiDimTableTypeTraits to be provided. In case of TierTableAdapter
-/// it will never going to be used, therefore specify a dummy implementation
-/// with assertion that its never get called.
+/// Note: MultiDimTable<double_pair, unsigned int> requires a conversion
+/// between double_pair and std::string (via value_cast). Because of a twist
+/// in TierTableAdapter (see the general note above) it will never be used.
+/// Therefore specify a dummy conversion and add an extra-assertion to make
+/// sure it never gets called.
 
-template <>
-class MultiDimTableTypeTraits<double_pair>
+struct FakeConversion
 {
 // TODO ?? EVGENIY !! Is an actual implementation needed?
     void fail() const
     {
         fatal_error() << "Dummy implementation called." << LMI_FLUSH;
     }
-
   public:
-    /// Convert value respresented by a string into ValueType.
-    double_pair FromString(std::string const&) const
+    tier_entity_adapter::double_pair StringToValue(std::string const&) const
     {
         fail();
-        return double_pair(0, 0);
+        throw "Unreachable--silences a compiler diagnostic.";
     }
-
-    /// Create a string representation of a value
-    std::string ToString(double_pair const&) const
+    std::string ValueToString(tier_entity_adapter::double_pair const&) const
     {
         fail();
-        return "";
+        throw "Unreachable--silences a compiler diagnostic.";
     }
 };
 
@@ -228,13 +199,13 @@
 /// bands.
 
 class TierTableAdapter
-  :public MultiDimTable1<double_pair, unsigned int>
+  :public MultiDimTable<tier_entity_adapter::double_pair, TierTableAdapter, FakeConversion>
 {
     friend class TierEditorGrid;
 
-    typedef MultiDimTable1<double_pair, unsigned int> Base;
-
   public:
+    typedef tier_entity_adapter::double_pair double_pair;
+
     TierTableAdapter(tier_entity_adapter entity = tier_entity_adapter());
     virtual ~TierTableAdapter();
 
@@ -249,18 +220,21 @@
     void SetBandsCount(unsigned int n);
     unsigned int GetBandsCount() const;
 
+    double_pair DoGetValue(Coords const&) const;
+    void        DoSetValue(Coords const&, double_pair const&);
+
   private:
-    // MultiDimTableAny method overrides
-    virtual bool VariesByDimension(unsigned int n) const;
+    // MultiDimTableAny required implementation.
     virtual bool CanChangeVariationWith(unsigned int n) const;
+    virtual unsigned int DoGetDimension() const {return 1;}
     virtual void MakeVaryByDimension(unsigned int n, bool varies);
-    virtual MultiDimAxis<unsigned int>* GetAxis0();
+    virtual AxesAny DoGetAxesAny();
+    virtual bool VariesByDimension(unsigned int n) const;
+
+    // MultiDimTableAny overrides.
     virtual bool DoApplyAxisAdjustment(MultiDimAxisAny&, unsigned int n);
     virtual bool DoRefreshAxisAdjustment(MultiDimAxisAny&, unsigned int n);
 
-    virtual double_pair GetValue(unsigned int band) const;
-    virtual void        SetValue(unsigned int band, double_pair const& value);
-
     void EnsureIndexIsZero(unsigned int) const;
 
     tier_entity_adapter entity_;
@@ -348,6 +322,12 @@
     :public MultiDimGrid
 {
   public:
+    typedef tier_entity_adapter::double_pair double_pair;
+
+    /// Default constructor, use Create() to really create the control.
+    TierEditorGrid();
+    virtual ~TierEditorGrid();
+
     TierEditorGrid
         (wxWindow* parent
         ,boost::shared_ptr<TierTableAdapter> const& table
@@ -355,23 +335,46 @@
         ,wxPoint const& pos = wxDefaultPosition
         ,wxSize const& size = wxDefaultSize
         );
-    virtual ~TierEditorGrid();
 
-  private:
-    double_pair GetDoublePairValue(int row);
+    bool Create
+        (wxWindow* parent
+        ,boost::shared_ptr<TierTableAdapter> const& table
+        ,wxWindowID id = wxID_ANY
+        ,wxPoint const& pos = wxDefaultPosition
+        ,wxSize const& size = wxDefaultSize
+        );
 
+  protected:
     /// Override class MultiDimGrid to show pairs of doubles as two
     /// columns in the grid.
 
     // MultiDimGrid overrides.
-    virtual int      GetNumberCols();
-    virtual int      GetNumberRows();
-    virtual wxString GetValue(int row, int col);
-    virtual void     SetValue(int row, int col, wxString const& str);
-    virtual wxString GetColLabelValue(int col);
-    virtual wxString GetRowLabelValue(int row);
+    virtual unsigned int DoGetNumberCols() const;
+    virtual unsigned int DoGetNumberRows() const;
+    virtual std::string DoGetValue(unsigned int row, unsigned int col) const;
+    virtual void        DoSetValue
+        (unsigned int row
+        ,unsigned int col
+        ,std::string const&
+        );
+    virtual std::string DoGetColLabelValue(unsigned int col) const;
+    virtual std::string DoGetRowLabelValue(unsigned int row) const;
+
+  private:
+    enum enum_tier_grid_column
+        {e_column_limit = 0
+        ,e_column_value
+        ,e_column_max
+        };
+    double_pair GetDoublePairValue(int row) const;
+
+    enum_tier_grid_column EnsureValidColumn(int col) const;
+
+    static std::string DoubleToString(double);
+    static double      StringToDouble(std::string const&);
 
-    void CheckRowAndCol(int row, int col) const;
+    // Label used in the editor for the highest representable number - DBL_MAX.
+    static std::string highest_representable_label_;
 };
 
 #endif // tier_view_editor_hpp
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/view_ex.cpp lmi-editor/view_ex.cpp
--- cvs/view_ex.cpp	2008-02-02 12:23:10.000000000 +0100
+++ lmi-editor/view_ex.cpp	2008-02-08 14:57:58.000000000 +0100
@@ -46,6 +46,7 @@
 // the wx framework.
 
 #include "alert.hpp"
+#include "assert_lmi.hpp"
 #include "docmanager_ex.hpp"
 #include "main_wx.hpp" // wxGetApp()
 #include "path_utility.hpp"
@@ -151,7 +152,12 @@
     wxGetApp().CreateChildFrame(doc, this);
     DocManager().AssociateFileHistoryWithFileMenu(FrameWindow().GetMenuBar());
     GetFrame()->SetLabel("Loading document...");
-    CreateChildWindow()->SetFocus();
+
+    wxWindow* child = CreateChildWindow();
+    LMI_ASSERT(child);
+    LMI_ASSERT(child->GetParent() == GetFrame());
+
+    child->SetFocus();
 
     // WX !! This should be done inside the library.
 #ifdef __X__
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/xml_lmi.cpp lmi-editor/xml_lmi.cpp
--- cvs/xml_lmi.cpp	2008-01-10 18:31:47.000000000 +0100
+++ lmi-editor/xml_lmi.cpp	2008-01-30 21:04:28.000000000 +0100
@@ -223,7 +223,15 @@
     ,std::string const& content
     )
 {
-    element.push_back(xml::element(name.c_str(), content.c_str()));
+    if(content.empty())
+        {
+        element.push_back(xml::element(name.c_str()));
+        }
+    else
+        {
+        // Even a NULL string results in an empty text child node.
+        element.push_back(xml::element(name.c_str(), content.c_str()));
+        }
 }
 
 xml_lmi::ElementContainer child_elements
